
function onDataReceived(rawdata) {
    //console.log("onDataReceived");
    var data = rawdata.total_download;
    // data is list of {.size,.k,.elapsed}
    data = data.filter(function (d) {return d.size == 1*1000*1000;});
    $("#title").text("Download performance data: 1MB");
    //console.log("got "+data.length+" trials");

    var frame = d3.select("#frame");
    var w = Number(frame.style("width").slice(0,-2));
    var h = Number(frame.style("height").slice(0,-2));
    //console.log("width is "+w+", h is "+h);
    h = 300;
    var graph = frame.append("svg:svg")
        .attr("id", "graph")
        .attr("width", w)
        .attr("height", h+45)
    ;
    w = w-35;
    //graph.append("svg:text").attr("dy", "10px")
    //    .attr("fill", "black").text("hello world")
    //;

    var padding = 20;
    var elapsed = data.map(function(d) {return d.elapsed;})
        .sort(d3.ascending);
    var percentile_99 = elapsed[(elapsed.length*0.99).toFixed()];
    //console.log(elapsed);
    //console.log(percentile_99);
    var max_elapsed = d3.max(data, function (d) {return d.elapsed;});
    //console.log("max elapsed is "+max_elapsed);
    var min_elapsed = d3.min(data, function (d) {return d.elapsed;});
    //console.log("min elapsed is "+min_elapsed);
    var max_k = d3.max(data, function (d) {return d.k;});
    //console.log("max k is "+max_k);
    var min_k = d3.min(data, function (d) {return d.k;});
    //console.log("min k is "+min_k);
    max_elapsed = percentile_99 * 1.10;
    var x = d3.scale.linear()
        .domain([min_k, max_k]).range([35+padding/2, w-padding/2]);
    var y = d3.scale.linear()
        .domain([0, max_elapsed]).range([h-padding/2, padding/2]);
    function tx(d) { return "translate(" +x(d) + ",0)"; }
    function ty(d) { return "translate(0," +y(d) + ")"; }

    var vis = graph.selectAll("circle")
        .data(data)
      .enter().append("svg:circle")
        .attr("class", "dot")
        .attr("cx", function(d) { return x(d.k); })
        .attr("cy", function(d) { return y(d.elapsed); })
        .attr("r", 3)
        .attr("fill", "white")
        .attr("stroke", "red")
        .attr("title", function(d) { return "k="+d.k+" elapsed="+d.elapsed; })
    ;

    var xrules = graph.selectAll("g.xrule")
        .data(x.ticks(10))
        .attr("transform", tx);
    xrules.select("text").text(x.tickFormat(10));
    var newxrules = xrules.enter().insert("svg:g")
        .attr("class", "xrule")
        .attr("transform", tx);
    newxrules.append("svg:line")
        .attr("y1", h)
        .attr("y2", h + 6)
        .attr("stroke", "black");
    newxrules.append("svg:line")
        .attr("y1", 0)
        .attr("y2", h)
        .attr("stroke", "red")
        .attr("stroke-opacity", .3);
    newxrules.append("svg:text")
        .attr("y", h+9)
        .attr("dy", ".71em")
        .attr("text-anchor", "middle")
        .attr("fill", "black")
        .text(x.tickFormat(10));
    xrules.exit().remove();
    graph.append("svg:text")
        .attr("class", "k-label")
        .attr("y", h+35)
        .attr("x", w/2)
        .attr("text-anchor", "middle")
        .attr("fille", "black")
        .text("shares");

    var yrules = graph.selectAll("g.yrule")
        .data(y.ticks(10))
        .attr("transform", ty);
    yrules.select("text").text(y.tickFormat(10));
    var newyrules = yrules.enter().insert("svg:g")
        .attr("class", "yrule")
        .attr("transform", ty);
    newyrules.append("svg:line")
        .attr("x1", 30)
        .attr("x2", 36)
        .attr("stroke", "black");
    newyrules.append("svg:line")
        .attr("x1", 36)
        .attr("x2", w)
        .attr("stroke", "red")
        .attr("stroke-opacity", .3);
    newyrules.append("svg:text")
        .attr("x", 25)
        .attr("dy", ".35em")
        .attr("text-anchor", "end")
        .attr("fill", "black")
        .text(y.tickFormat(10));
    yrules.exit().remove();
    graph.append("svg:text")
        .attr("class", "seconds-label")
        .attr("y", 10)
        .attr("x", 0)
        .attr("text-anchor", "start")
        .attr("fille", "black")
        .text("seconds");
    
};

$(function() {

      $.ajax({url: "data.json",
              method: 'GET',
              dataType: 'json',
              success: onDataReceived });
});

